﻿// SpaceShip class (w/bonus tractor beam) by Grant Skinner [ http://gskinner.com/ ] for
// FlashMX 2004 Demystified, published by Macromedia Press.

// Have fun!

class SpaceShip extends MovieClip {
	// define properties
	var velocityX:Number = 0;
	var velocityY:Number = 0;
	
	// define the constructor
	function SpaceShip() {
		Key.addListener(this);
	}
	
	// define methods:
	function onKeyDown():Void {
		// get the keyCode for the last key that was pressed:
		var keyCode:Number = Key.getCode();
		// carry out the appropriate action, depending on what key was pressed:
		switch (keyCode) {
			case Key.LEFT:
				thrustX(-1);
				break;
			case Key.RIGHT:
				thrustX(1);
				break;
			case Key.UP:
				thrustY(-1);
				break;
			case Key.DOWN:
				thrustY(1);
				break;
		}
	}
	function thrustX(direction:Number):Void {
		velocityX += direction;
	}
	function thrustY(direction:Number):Void {
		velocityY += direction;
	}
	function onEnterFrame():Void {
		// apply some friction for nicer motion:
		velocityX *= 0.92;
		velocityY *= 0.92;
		
		// move me:
		_x += velocityX;
		_y += velocityY;
		
		// BONUS!! Tractor beam:
		this.clear();
		if (Key.isDown(Key.SPACE)) {
			// draw a random pulsing beam using the lineStyle method we inherited from MovieClip:
			this.lineStyle(random(10)+34,0xFFFFFF,random(10)+5);
			this.lineTo(0,1000);
			this.lineStyle(random(10)+6,0xFFFFFF,random(10)+2);
			this.lineTo(0,0);
		}
	}
}